#include <iostream>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <main.h>
#include <pthread.h>

using namespace std;

// GLOBAL VARIABLE!!!
// This variable appears in the "static data" area of the
// process address space.  That means all threads can 
// access and manipulate the variable.
int sum;

void* summation(void* param);
// Precondition:  param is declared as a (void*) pointer so that
//                it will be compatible with the pthread_create call.
//                In reality, though, param should be a the address 
//                of an integer variable.]
//
// Postcondition: sets the global variable "sum" to the summation
//                of all integers up to the integer whose address
//                was passed in as param.
//
//                Example: 
//                           sum=0;
//                           int theNum=10;
//                           summation(&theNum);
//                           cout << sum << endl;
//                 
//                           OUTPUTS: 55

int main(void)
{
  // Thread identifier
  pthread_t tid0; 


  // Create thread
  int theNum0 = 10;
  pthread_create(&tid0,NULL,summation, &theNum0);

  // Wait for thread to exit
  pthread_join(tid0,NULL);

  // Output sum
  cout << "Summation computed by thread is: " << sum << endl;
}

void* summation(void* param)
{
  // Delay for 5 seconds
  sleep(5);

  // Convert (void *) parameter to (int *) parameter
  // then get the integer.
  int theNum = *((int *) param);
  cout << "Computing summation of " << theNum << endl;

  // Compute summation
  sum = 0;
  for (int i=1; i<=theNum; i++) {
    sum += i;
  }

  // Thread exit
  pthread_exit(0);
}
